﻿'Adapted from "Programming Windows Phone 7," XNA part, "Dynamic Textures" chapter, "Geometry of Line Drawing" section
    Public Structure ArcGeometrySegment
    Implements IGeometrySegment

    Private ReadOnly angle1, angle2 As Double

    Public Sub New(ByVal center As Point,
                   ByVal radius As Double,
                   ByVal point1 As Point,
                   ByVal point2 As Point)
        Me.Center = center
        Me.Radius = radius
        Me.Point1 = point1
        Me.Point2 = point2
        angle1 = Math.Atan2(point1.Y - center.Y, point1.X - center.X)
        angle2 = Math.Atan2(point2.Y - center.Y, point2.X - center.X)
    End Sub

    Private _Center As Point
    Public Property Center As Point
        Get
            Return _Center
        End Get
        Private Set(ByVal value As Point)
            _Center = value
        End Set
    End Property

    Private _Radius As Double
    Public Property Radius As Double
        Get
            Return _Radius
        End Get
        Private Set(ByVal value As Double)
            _Radius = value
        End Set
    End Property

    Private _Point1 As Point
    Public Property Point1 As Point
        Get
            Return _Point1
        End Get
        Private Set(ByVal value As Point)
            _Point1 = value
        End Set
    End Property

    Private _Point2 As Point
    Public Property Point2 As Point
        Get
            Return _Point2
        End Get
        Private Set(ByVal value As Point)
            _Point2 = value
        End Set
    End Property

    Public Sub GetAllX(ByVal y As Double, ByVal xCollection As IList(Of Double)) Implements IGeometrySegment.GetAllX
        'Quick check that we're in the ballpark
        If Math.Abs(y - Center.Y) > Radius Then
            Return
        End If

        Dim sqrtArg As Double = Radius * Radius - (y - Center.Y) * (y - Center.Y)

        If sqrtArg >= 0 Then
            Dim sqrt As Double = Math.Sqrt(sqrtArg)
            TryY(y, Center.X + sqrt, xCollection)
            TryY(y, Center.X - sqrt, xCollection)
        End If
    End Sub

    Public Sub TryY(ByVal y As Double, ByVal x As Double, ByVal xCollection As IList(Of Double))
        Dim angle As Double = Math.Atan2(y - Center.Y, x - Center.X)

        If (angle1 < angle2 AndAlso (angle1 <= angle AndAlso angle < angle2)) OrElse
            (angle1 > angle2 AndAlso (angle1 <= angle OrElse angle < angle2)) Then
            xCollection.Add(x)
        End If
    End Sub
End Structure
