﻿'Adapted from "Programming Windows Phone 7," XNA part, "Dynamic Textures" chapter, "Geometry of Line Drawing" section

   Public Structure LineGeometrySegment
    Implements IGeometrySegment

    Private ReadOnly a, b As Double ' as in x = ay + b

    Public Sub New(ByVal point1 As Point, ByVal point2 As Point)
        Me.Point1 = point1
        Me.Point2 = point2

        a = (Me.Point2.X - Me.Point1.X) / (Me.Point2.Y - Me.Point1.Y)
        b = Me.Point1.X - a * Me.Point1.Y
    End Sub

    Private _Point1 As Point
    Public Property Point1 As Point
        Get
            Return _Point1
        End Get
        Private Set(ByVal value As Point)
            _Point1 = value
        End Set
    End Property

    Private _Point2 As Point
    Public Property Point2 As Point
        Get
            Return _Point2
        End Get
        Private Set(ByVal value As Point)
            _Point2 = value
        End Set
    End Property

    Public Sub GetAllX(ByVal y As Double, ByVal xCollection As IList(Of Double)) Implements IGeometrySegment.GetAllX
        If (Point2.Y > Point1.Y AndAlso y >= Point1.Y AndAlso y < Point2.Y) OrElse (Point2.Y < Point1.Y AndAlso y <= Point1.Y AndAlso y > Point2.Y) Then
            xCollection.Add(a * y + b)
        End If
    End Sub
End Structure