﻿'Adapted from "Programming Windows Phone 7," XNA part, "Dynamic Textures" chapter, "Geometry of Line Drawing" section

  Public Structure RoundCappedLine
    Implements IGeometrySegment

    Private lineSegment1 As LineGeometrySegment
    Private arcSegment1 As ArcGeometrySegment
    Private lineSegment2 As LineGeometrySegment
    Private arcSegment2 As ArcGeometrySegment

    Public Sub New(ByVal point1 As Point, 
                   ByVal point2 As Point, 
                   ByVal radius As Double)
        Me.Point1 = point1
        Me.Point2 = point2
        Me.Radius = radius

        Dim vector As New Point(point2.X - point1.X, point2.Y - point1.Y)
        Dim length As Double = Math.Sqrt(vector.X * vector.X + vector.Y * vector.Y)
        Dim normVect As New Point(vector.X / length, vector.Y / length)

        Dim pt1a As New Point(point1.X + radius * normVect.Y, point1.Y - radius * normVect.X)
        Dim pt2a As New Point(pt1a.X + vector.X, pt1a.Y + vector.Y)
        Dim pt1b As New Point(point1.X - radius * normVect.Y, point1.Y + radius * normVect.X)
        Dim pt2b As New Point(pt1b.X + vector.X, pt1b.Y + vector.Y)

        lineSegment1 = New LineGeometrySegment(pt1a, pt2a)
        arcSegment1 = New ArcGeometrySegment(point2, radius, pt2a, pt2b)
        lineSegment2 = New LineGeometrySegment(pt2b, pt1b)
        arcSegment2 = New ArcGeometrySegment(point1, radius, pt1b, pt1a)
    End Sub

    Private _Point1 As Point
    Public Property Point1 As Point
        Get
            Return _Point1
        End Get
        Private Set(ByVal value As Point)
            _Point1 = value
        End Set
    End Property
    Private _Point2 As Point
    Public Property Point2 As Point
        Get
            Return _Point2
        End Get
        Private Set(ByVal value As Point)
            _Point2 = value
        End Set
    End Property
    Private _Radius As Double
    Public Property Radius As Double
        Get
            Return _Radius
        End Get
        Private Set(ByVal value As Double)
            _Radius = value
        End Set
    End Property

    Public Sub GetAllX(ByVal y As Double, ByVal xCollection As IList(Of Double)) Implements IGeometrySegment.GetAllX
        Dim count As Integer = xCollection.Count

        arcSegment1.GetAllX(y, xCollection)
        lineSegment1.GetAllX(y, xCollection)
        arcSegment2.GetAllX(y, xCollection)
        lineSegment2.GetAllX(y, xCollection)

        'Ensure collection has pairs of points
        If xCollection.Count = count + 1 Then
            xCollection.Add(xCollection(xCollection.Count - 1))
        End If
    End Sub
End Structure
