﻿    Public Class SineCurve
    Inherits FrameworkElement
    Implements IProvideAxisValue

    Private phaseAngle As Double = 0
    Private lastDateTime As Date = Date.Now

    'Frequency in cycles per second
    Public Shared ReadOnly FrequencyProperty As DependencyProperty =
        DependencyProperty.Register("Frequency", GetType(Double), GetType(SineCurve), New PropertyMetadata(1.0))

    Public Shared ReadOnly AmplitudeProperty As DependencyProperty =
        DependencyProperty.Register("Amplitude", GetType(Double), GetType(SineCurve), New PropertyMetadata(1.0))

    Public Property Frequency As Double
        Set(ByVal value As Double)
            SetValue(FrequencyProperty, value)
        End Set
        Get
            Return CDbl(GetValue(FrequencyProperty))
        End Get
    End Property

    Public Property Amplitude As Double
        Set(ByVal value As Double)
            SetValue(AmplitudeProperty, value)
        End Set
        Get
            Return CDbl(GetValue(AmplitudeProperty))
        End Get
    End Property

    Public Function GetAxisValue(ByVal dateTime As Date) As Double Implements IProvideAxisValue.GetAxisValue
        phaseAngle += 2 * Math.PI * Me.Frequency * (dateTime.Subtract(lastDateTime)).TotalSeconds
        phaseAngle = phaseAngle Mod 2 * Math.PI
        lastDateTime = dateTime

        Return Me.Amplitude * Math.Sin(phaseAngle)
    End Function
End Class